import os        #Various tasks, most noteably file management
import shutil    #Copying files
import cStringIO #Reading and writing content
import string    #Converting raw_input()'s to integers
import time      #Timestamping
import rotor     #Passwords
from getpass import getpass #Passwords


#########################

class Variables:
	DATA_DIR = os.environ['HOME'] + '/.journal/' #Directory where all files go
	MAINFILE = DATA_DIR #Journal file; CURUSER added onto it after login
	TMPFILE = DATA_DIR + 'tmp.journ' #File that the program works with
	BAKFILE = DATA_DIR #Where a backup is created; CURUSER added onto it after login
	VERSION = '0.4' #Current version
	PROMPT = '--> ' #Prompt for main menu
	PASSFILE = DATA_DIR + 'passwd' #File containing users/passwords
	CURUSER = '' #Assigned during login
	PASSWORD = '' #The user's password; used for encrypting content

#########################

class Entry: #Holds data about all the entries read from the file
	title = []
	time = []
	content = []

#########################

class Journal:
	def __init__(self, vars):
		#Create an empty file if there is no main one.
		os.system('touch ' + vars.MAINFILE) 

		#Copy the mainfile into TMPFILE, to be manipulated
		shutil.copyfile(vars.MAINFILE, vars.TMPFILE)


	def new_entry(self, vars): #Called from the main menu
		file = open(vars.TMPFILE, 'a') #Add an entry to the end of the file.
		title = raw_input('Title--> ') #Read title.

		# Create a buffer to write all content to
		content = cStringIO.StringIO()

		print 'Content (enter a . on a blank line to end): \n'

		#Loop to read content, break on a '.' by itself
		while 1:
			temp = raw_input('> ')
			if temp == '.':
				break
			content.write(temp + '\n') #Write line into content
		entry_time = time.time() #Get timestamp

		#Encrypt content
		rt = rotor.newrotor(vars.PASSWORD)

		file.write(':::' + rt.encrypt(`entry_time`) + ':::' + rt.encrypt(title) + '\n' \
		+ rt.encrypt(content.getvalue()) + '\n')

		file.close()

	def backup(self, vars): #Create a backup of the main file.
		shutil.copyfile(vars.MAINFILE, vars.BAKFILE)
		print vars.MAINFILE + ' copied into ' + vars.BAKFILE + '.'
		wait = raw_input('<press enter>')


	def save(self, vars):
		shutil.copyfile(vars.TMPFILE, vars.MAINFILE) #Save the manipulated TMPFILE

#########################

class Menu: #Main program structure
	def __init__(self, vars):
		self.text = [] #Main menu
		self.text.append('Journal ' + vars.VERSION + '\n')
		self.text.append('Select:')
		self.text.append('  1) Create a new entry')
		self.text.append('  2) Browse entries')
		self.text.append('  3) Save')
		self.text.append('  4) Make a backup')
		self.text.append('  5) Add another user')
		self.text.append('')
		self.text.append('  0) Exit \n')


	def printmenu(self): #Print the main menu
		os.system('clear')
		for line in self.text:
			print line


	def selection(self, journal, browse, vars): #Get selection from the menu
		self.printmenu()
		choice = raw_input(vars.PROMPT)
		if choice == '1':
			journal.new_entry(vars)
		elif choice == '2':
			browse.browse(vars)
		elif choice == '3':
			journal.save(vars)
		elif choice == '4':
			journal.backup(vars)
		elif choice == '5':
			add_user(vars)
		elif choice == '0':
			print 'Save changes? (Y/n)' #Save upon exit unless the user enters 'n'
			saveonexit = raw_input()
			if saveonexit != 'n':
				journal.save(vars)
			# Cleanup:
			os.system('rm ' + vars.TMPFILE) #Remove the TMPFILE
			return 0

#########################

class Browser(Journal): #Used to view past entries
	def read_file(self, vars):
		file = open(vars.TMPFILE, 'r')
		self.all_lines = file.readlines() #Read all of the TMPFILE into self.all_lines
		file.close()
		self.title_lines = []
		x = 0

		#Determine which line numbers are the beginning of entries:
		for temp in self.all_lines:
			if temp[:3] == ':::':
				self.title_lines.append(x)
			x = x+1
		
		#Reverse list in order to have entries from newest to oldest
		self.title_lines.reverse()
		self.get_entries()

	def get_entries(self): #Fill entry class with all titles, times, and contents
		self.entry = Entry()
		x = 0
		for n in self.title_lines:
			self.entry.title.append(self.get_title(n))
			self.entry.time.append(self.get_time(n))
			self.entry.content.append(self.get_content(n))
			x = x+1


	def get_title(self, n): #Get the title from line n
		x = 3 #Start off after the first ':::'
		line = self.all_lines[n]
		title = ''
		while line[x] != ':': #Go past the timestamp
			x = x+1
		x = x+3 #Go past the ':::' following the timestamp
		while line[x] != '\012': #Read until newline
			title = title + line[x]
			x = x+1
		return title


	def get_time(self, n):
		x = 3 #Start off after initial ':::'
		line = self.all_lines[n]
		entry_time = ''
		while line[x] != ':': #Read until another ':' is encountered
			entry_time = entry_time + line[x]
			x = x+1
		#entry_time = time.ctime(string.atof(entry_time)) #Convert time to a nice string
		return entry_time


	def get_content(self, n):
		x = 1

		try:
			line = self.all_lines[n+x]
		except IndexError: #In case of a blank entry
			return ''

		content = cStringIO.StringIO()

		while line[:3] != ':::': #Read lines until a line is encountered that begins with ':::'
			content.write(line)
			x = x+1
			try:
				line = self.all_lines[n+x]
			except IndexError: #In case of a blank entry
				break
		return content.getvalue()

	
	def browse(self, vars): #Function that calls the rest
		self.read_file(vars)
		while 1:
			os.system('clear')
			self.print_entries(vars)
			choice = raw_input('<View Entry> ')
			if choice == 'M': #Return to main menu on 'M' or 'm'
				break
			elif choice == 'm':
				break
			try:
				num_choice = string.atoi(choice) #Convert input into an integer if possible
				if num_choice < 1: #Disallow input of 0 or less
					print 'Please enter a valid response! (Press enter)'
					x = raw_input()
				else:
					self.print_entry(num_choice-1, vars)
			except (ValueError, IndexError):
				print 'Please enter a valid response! (Press enter)'
				x = raw_input()


	def print_entries(self, vars): #Print all entries in form: <NUM> TIME -- TITLE
		rt = rotor.newrotor(vars.PASSWORD)
		for x in range(len(self.title_lines)):
			print '<' + `x+1` + '> ' + time.ctime(string.atof(rt.decrypt(self.entry.time[x]))) + ' -- ' + rt.decrypt(self.entry.title[x])
		print '\n<M> Main Menu\n'


	def print_entry(self, number, vars): #Print entry number 'number'
		rt = rotor.newrotor(vars.PASSWORD)

		print '\n' + time.ctime(string.atof(rt.decrypt(self.entry.time[number]))) + ' -- ' + rt.decrypt(self.entry.title[number]) + '\n'
		content = rt.decrypt(self.entry.content[number])
		print content[:-1] #After decryption, it added a strange character at the end... very weird.
		temp = raw_input('<Press enter>')

#########################

def login(vars):
	try:
		os.chdir(vars.DATA_DIR) #chdir to DATA_DIR
	except OSError:
		os.mkdir(vars.DATA_DIR) #create DATA_DIR if it doesn't exist
		os.chdir(vars.DATA_DIR)

	fileline = [] #Holds lines in passwd
	fileuser = [] #Holds users in passwd
	filepass = [] #Holds passwords in passwd
	tries = 0  #Record attempts at the username and at the password; kick after 3 incorrect
	y = 0
	os.system('clear')

	try:
		passfile = open(vars.PASSFILE, 'r')
	except IOError:   # The file's not there.
		print 'Error: passwd file not found.'
		print 'If this is the first execution, don\'t worry about it.'
		os.system('touch ' + vars.PASSFILE) #Create passfile
		passfile = open(vars.PASSFILE, 'w')
		username = raw_input('\nYour user name: ') 
		pass1 = getpass('Password: ') #Make sure they know their password
		pass2 = getpass('Re-type password: ')
		while pass1 != pass2:
			print 'Error! Passwords not the same!'
			pass1 = getpass('Password: ')
			pass2 = getpass('Re-type password: ')
		rt = rotor.newrotor(username, 12)
		passfile.write(username + '::' + rt.encryptmore(pass1) + '\n')
		passfile.close()
	os.system('clear')
	print 'Login to Journal ' + vars.VERSION + '\n'
	passfile = open(vars.PASSFILE, 'r')
	fileline = passfile.readlines()
	for line in fileline:
		y = 0
		if line != '': #Skip blank lines
			for x in line:
				if x == ':':
					break
				else:
					y = y+1
			endusername = y #y is where the first ':' is
			beginpassword = endusername+2 #First char of password
			fileuser.append(line[:endusername])
			filepass.append(line[beginpassword:(len(line)-1)])
	
	usernum = -1
	while usernum == -1:
		y = 0
		user = raw_input('User name: ')

		for known in fileuser: #Make sure the user exists
			if known == user:
				usernum = y
			y = y+1
		if usernum == -1:
			print 'Error: user ' + user + ' not found.'
			tries = tries + 1
			if tries == 3:
				print 'Sorry, you lose.\n'
				return 0

	tries = 0
	vars.CURUSER = user

	vars.MAINFILE = vars.MAINFILE + vars.CURUSER + '.journ'
	vars.BAKFILE = vars.BAKFILE + vars.CURUSER + '.bak'

	correct_pw = -1
	while correct_pw == -1:
		rt = rotor.newrotor(user, 12)
		password = getpass('Password: ')
		passencrypted = rt.encryptmore(password)
		if passencrypted == filepass[usernum]: #Make sure the password matches the user they put
			correct_pw = 1
			vars.PASSWORD = password
			return 1
		print 'Error: incorrect password for ' + user + '.'
		tries = tries + 1
		if tries == 3:
			print 'Sorry, you lose.\n'
			return 0

#########################

def add_user(vars):
	os.system('clear')
	file = open(vars.PASSFILE, 'r') #It's there because it was created on execution if it wasn't there before
	fileline = [] #Read existing file
	fileuser = [] #To make sure they don't pick the same name twice

	fileline = file.readlines()
	file.close()

	for line in fileline:
		endusername = 0
		if line != '': #Skip blank lines
			for x in line:
				if x != ':':
					endusername = endusername + 1
				else:
					break
			fileuser.append(line[:endusername])

	okname = -1

	while okname == -1:
		newuser = raw_input('New user name: ')
		for name in fileuser:
			if newuser == name:
				okname = -1
				print ('Error: user ' + name + ' already exists! Press enter to continue.'),
				raw_input()
				break
			okname = 1

	passmatch = -1

	while passmatch == -1:
		pass1 = getpass('Password: ')
		pass2 = getpass('Re-type password: ')
		if pass1 != pass2:
			print 'Error! Passwords do not match!'
		else:
			passmatch = 1

	rt = rotor.newrotor(newuser, 12)

	file = open(vars.PASSFILE, 'a')
	file.write(newuser + '::' + rt.encryptmore(pass1) + '\n')
	file.close()

	print 'User ' + newuser + ' successfully added. <Press enter>'
	raw_input()
